exec("./ColorChat.gui");

if(isFile("Config/Client/colorChat.cs"))
{
	exec("Config/Client/colorChat.cs");
}

package colorChat
{
	function clientCmdChatMessage(%client,%b,%c,%taggedString,%preTag,%name,%postTag,%msg)
	{
		%row = NPL_List.getRowTextById(%client);
		%blid = getField(%row, 3);

		if(isColorChatID(%blid))
		{
			if($ColorChat::Prefix[%blid] !$= "")
			{
				%preTag = "<color:"@$ColorChat::Prefix[%blid]@">"@%preTag;
			}
			else
			{
				%preTag = "\c7"@%preTag;
			}
			if($ColorChat::Suffix[%blid] !$= "")
			{
				%postTag = "<color:"@$ColorChat::Suffix[%blid]@">"@%postTag;
			}
			else
			{
				%postTag = "\c7"@%postTag;
			}
			if($ColorChat::Name[%blid] !$= "")
			{
				%name = "<color:"@$ColorChat::Name[%blid]@">"@%name;
			}
			else
			{
				%name = "\c3"@%name;
			}
			if($ColorChat::Msg[%blid] !$= "")
			{
				%msg = "<color:"@$ColorChat::Msg[%blid]@">: "@%msg;
			}
			else
			{
				%msg = "\c6: "@%msg;
			}
		}
		else
		{
			if($ColorChat::Prefix !$= "")
			{
				%preTag = "<color:"@$ColorChat::Prefix@">"@%preTag;
			}
			else
			{
				%preTag = "\c7"@%preTag;
			}
			if($ColorChat::Suffix !$= "")
			{
				%postTag = "<color:"@$ColorChat::Suffix@">"@%postTag;
			}
			else
			{
				%postTag = "\c7"@%postTag;
			}
			if($ColorChat::Name !$= "")
			{
				%name = "<color:"@$ColorChat::Name@">"@%name;
			}
			else
			{
				%name = "\c3"@%name;
			}
			if($ColorChat::Msg !$= "")
			{
				%msg = "<color:"@$ColorChat::Msg@">: "@%msg;
			}
			else
			{
				%msg = "\c6: "@%msg;
			}
		}

		%taggedString = %preTag @ %name @ %postTag @ %msg;

		Parent::clientCmdChatMessage(%client,%b,%c,%taggedString,%preTag,%name,%postTag,%msg);
	}
};
activatePackage(colorChat);

function ColorChat_AddID(%add,%count)
{
	if(!isColorChatID(%add))
	{
		$ColorChat::friend[$ColorChat::Count++] = %add;
		ColorChat_IDList.addRow(%count,%add);
		export("$ColorChat::*","Config/Client/colorChat.cs");
	}
	ColorChat_IDText.setValue("");
}
function ColorChat_RemoveID(%rem)
{
	deleteVariables("$ColorChat::friend"@%rem);
	%BLID = ColorChat_IDList.getRowTextByID(%rem);
	deleteVariables("$ColorChat::Pre"@%BLID);
	deleteVariables("$ColorChat::Name"@%BLID);
	deleteVariables("$ColorChat::Post"@%BLID);
	deleteVariables("$ColorChat::Msg"@%BLID);
	ColorChat_IDList.removeRowById(%rem);
	for(%i=(%rem + 1);%i<=$ColorChat::Count;%i++)
	{
		%current = $ColorChat::friend[%i];
		$ColorChat::friend[%i-1] = %current;
		deleteVariables("$ColorChat::friend"@%i);
	}
	$ColorChat::Count--;
	export("$ColorChat::*","Config/Client/colorChat.cs");

	ColorChat_IDList.clear();
	for(%i=1;%i<=$ColorChat::Count;%i++)
	{
		%curr = $ColorChat::friend[%i];
		ColorChat_IDList.addRow(%i,%curr);
	}
}
function ColorChat_ApplyID(%id)
{
	if(ColorChat_IDList.getSelectedID())
	{
		%blid = ColorChat_IDList.getRowTextByID(%id);
		$ColorChat::Pre[%blid] = ColorChat_Prefix.getValue();
		$ColorChat::Post[%blid] = ColorChat_Suffix.getValue();
		$ColorChat::Name[%blid] = ColorChat_Name.getValue();
		$ColorChat::Msg[%blid] = ColorChat_Msg.getValue();
		export("$ColorChat::*","Config/Client/colorChat.cs");
	}
}
function ColorChat_SelectID(%id)
{
	%id = ColorChat_IDList.getRowTextByID(%id);
	%name = $ColorChat::Name[%id];
	%pre = $ColorChat::Pre[%id];
	%post = $ColorChat::Post[%id];
	%msg = $ColorChat::Msg[%id];
	ColorChat_Name.setText(%name);
	ColorChat_Prefix.setText(%pre);
	ColorChat_Suffix.setText(%post);
	ColorChat_Msg.setText(%msg);
}
function isColorChatID(%id)
{
	for(%i=1;%i<=$ColorChat::Count;%i++)
	{
		%testID = $ColorChat::friend[%i];
		if(%testID == %id)
		{
			return 1;
		}
	}
	return 0;
}

function loadColorChat()
{
	for(%i=1;%i<=$ColorChat::Count;%i++)
	{
		%id = $ColorChat::friend[%i];
		ColorChat_IDList.addRow(%i,%id);
	}
}

if(!$ColorChatLoaded)
{
	loadColorChat();
	$remapDivision[$remapCount] = "Color Chat";
	$remapName[$remapCount] = "Open Color Chat Gui";
	$remapCmd[$RemapCount] = "OpenColorChatGui";
	$remapCount++;
	$ColorChatLoaded = 1;
}

function OpenColorChatGui()
{
	canvas.pushDialog(ColorChatGui);
}